Name:          libwd
Summary:       User Space Accelerator Development Kit
Version:       2.3.37
Release:       2
License:       Apache-2.0
Source:        %{name}-%{version}.tar.gz
Vendor:        Huawei Corporation
ExclusiveOS:   linux
URL:           https://support.huawei.com
BuildRoot:     %{_tmppath}/%{name}-%{version}-root
Conflicts:     %{name} < %{version}-%{release}
Provides:      %{name} = %{version}-%{release}
BuildRequires: numactl-devel, openssl-devel
BuildRequires: automake, autoconf, libtool
BuildRequires: gcc, make
ExclusiveArch: aarch64
Patch0001:     0001-uadk-v1-ecc-bugfix-buffer-overwritten-of-sm2-decrypt.patch
Patch0002:     0002-uadk-ecc-cleanup-sm2-dec-out-code.patch
Patch0003:     0003-uadk-v1-ecc-bugfix-incorrect-parameter-length.patch
Patch0004:     0004-uadk-ecc-bugfix-incorrect-parameter-length.patch

%description
This package contains the User Space Accelerator Library
for hardware accelerator, compress, symmetric encryption
and decryption, asymmetric encryption and decryption.

%prep
%global debug_package %{nil}
%autosetup -n %{name}-%{version} -p1

%build
sh autogen.sh
./configure
make

%install
mkdir -p ${RPM_BUILD_ROOT}/usr/lib64
install -b -m755 .libs/libwd.so.%{version} ${RPM_BUILD_ROOT}/usr/lib64
install -b -m755 .libs/libwd_crypto.so.%{version} ${RPM_BUILD_ROOT}/usr/lib64
install -b -m755 .libs/libwd_comp.so.%{version} ${RPM_BUILD_ROOT}/usr/lib64
install -b -m755 .libs/libhisi_sec.so.%{version} ${RPM_BUILD_ROOT}/usr/lib64
install -b -m755 .libs/libhisi_hpre.so.%{version} ${RPM_BUILD_ROOT}/usr/lib64
install -b -m755 .libs/libhisi_zip.so.%{version} ${RPM_BUILD_ROOT}/usr/lib64
mkdir -p ${RPM_BUILD_ROOT}/usr/include/warpdrive/include
cp v1/uacce.h ${RPM_BUILD_ROOT}/usr/include/warpdrive/include
cp v1/wd.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
cp v1/wd_cipher.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
cp v1/wd_comp.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
cp v1/wd_dh.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
cp v1/wd_digest.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
cp v1/wd_rsa.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
cp v1/wd_bmm.h ${RPM_BUILD_ROOT}/usr/include/warpdrive
mkdir -p ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp include/uacce.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_cipher.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_comp.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_dh.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_digest.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_rsa.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_aead.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_ecc.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_ecc_curve.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_alg_common.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_common.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp include/wd_sched.h ${RPM_BUILD_ROOT}/usr/include/uadk
cp v1/uacce.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd_cipher.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd_comp.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd_dh.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd_digest.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd_rsa.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1
cp v1/wd_bmm.h ${RPM_BUILD_ROOT}/usr/include/uadk/v1

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(755,root,root)
/usr/lib64/libwd.so.%{version}
/usr/lib64/libwd_crypto.so.%{version}
/usr/lib64/libwd_comp.so.%{version}
/usr/lib64/libhisi_sec.so.%{version}
/usr/lib64/libhisi_hpre.so.%{version}
/usr/lib64/libhisi_zip.so.%{version}
%defattr(644,root,root)
/usr/include/warpdrive/include/uacce.h
/usr/include/warpdrive/wd.h
/usr/include/warpdrive/wd_cipher.h
/usr/include/warpdrive/wd_comp.h
/usr/include/warpdrive/wd_dh.h
/usr/include/warpdrive/wd_digest.h
/usr/include/warpdrive/wd_rsa.h
/usr/include/warpdrive/wd_bmm.h
/usr/include/uadk/uacce.h
/usr/include/uadk/wd.h
/usr/include/uadk/wd_cipher.h
/usr/include/uadk/wd_comp.h
/usr/include/uadk/wd_dh.h
/usr/include/uadk/wd_digest.h
/usr/include/uadk/wd_rsa.h
/usr/include/uadk/wd_aead.h
/usr/include/uadk/wd_ecc.h
/usr/include/uadk/wd_ecc_curve.h
/usr/include/uadk/wd_alg_common.h
/usr/include/uadk/wd_common.h
/usr/include/uadk/wd_sched.h
/usr/include/uadk/v1/uacce.h
/usr/include/uadk/v1/wd.h
/usr/include/uadk/v1/wd_cipher.h
/usr/include/uadk/v1/wd_comp.h
/usr/include/uadk/v1/wd_dh.h
/usr/include/uadk/v1/wd_digest.h
/usr/include/uadk/v1/wd_rsa.h
/usr/include/uadk/v1/wd_bmm.h
%exclude /usr/lib64/libwd.so.2
%exclude /usr/lib64/libwd_crypto.so.2
%exclude /usr/lib64/libwd_comp.so.2
%exclude /usr/lib64/libhisi_sec.so.2
%exclude /usr/lib64/libhisi_hpre.so.2
%exclude /usr/lib64/libhisi_zip.so.2

%pre
if [ "$1" = "2" ] ; then  #2: update
    rm -rf /usr/lib64/libwd.so   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_crypto.so   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_crypto.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_comp.so   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_comp.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_sec.so   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_sec.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_hpre.so   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_hpre.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_zip.so   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_zip.so.2   > /dev/null 2>&1 || true
fi

%post
if [[ "$1" = "1" || "$1" = "2" ]] ; then  #1: install 2: update
    cd /usr/lib64
    ln -sf libwd.so.%{version} libwd.so
    ln -sf libwd.so.%{version} libwd.so.2
    ln -sf libwd_crypto.so.%{version} libwd_crypto.so
    ln -sf libwd_crypto.so.%{version} libwd_crypto.so.2
    ln -sf libwd_comp.so.%{version} libwd_comp.so
    ln -sf libwd_comp.so.%{version} libwd_comp.so.2
    ln -sf libhisi_sec.so.%{version} libhisi_sec.so
    ln -sf libhisi_sec.so.%{version} libhisi_sec.so.2
    ln -sf libhisi_hpre.so.%{version} libhisi_hpre.so
    ln -sf libhisi_hpre.so.%{version} libhisi_hpre.so.2
    ln -sf libhisi_zip.so.%{version} libhisi_zip.so
    ln -sf libhisi_zip.so.%{version} libhisi_zip.so.2
fi
/sbin/ldconfig

%preun
if [ "$1" = "0" ] ; then  #0: uninstall
    rm -rf /usr/lib64/libwd.so    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd.so.2    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_crypto.so    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_crypto.so.2    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_comp.so    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libwd_comp.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_sec.so    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_sec.so.2   > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_hpre.so    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_hpre.so.2    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_zip.so    > /dev/null 2>&1 || true
    rm -rf /usr/lib64/libhisi_zip.so.2    > /dev/null 2>&1 || true
fi

%postun
/sbin/ldconfig

%changelog
* Tue Dec 15 2022 Yang Shen <shenyang39@huawei.com> 2.3.37-2
- libwd: fix a bug for ecc

* Mon Oct 10 2022 Yang Shen <shenyang39@huawei.com> 2.3.37-1
- libwd: update the source code to 2.3.37

* Tue Jul 26 2022 Yang Shen <shenyang39@huawei.com> 2.3.21-6
- libwd: backport the patch of uadk from 2.3.31 to 2.3.36

* Mon Mar 21 2022 Yang Shen <shenyang39@huawei.com> 2.3.21-5
- libwd: backport the patch of uadk from 2.3.28 to 2.3.31

* Tue Mar 1 2022 Yang Shen <shenyang39@huawei.com> 2.3.21-4
- libwd: backport the patch of uadk from 2.3.27 to 2.3.28

* Mon Feb 21 2022 Yang Shen <shenyang39@huawei.com> 2.3.21-3
- libwd: backport the patch of uadk from 2.3.24 to 2.3.27

* Tue Jan 04 2022 Yang Shen <shenyang39@huawei.com> 2.3.21-2
- libwd: backport the patch of uadk from 2.3.21 to 2.3.24

* Mon Dec 06 2021 linwenkai <linwenkai6@hisilicon.com> 2.3.21-1
- libwd: update uadk from 2.3.20 to 2.3.21

* Wed Nov 24 2021 linwenkai <linwenkai6@hisilicon.com> 2.3.20-2
- libwd: add missing head files and fix install path

* Mon Nov 22 2021 Yang Shen <shenyang39@huawei.com> 2.3.20-1
- libwd: update uadk from 2.3.11 to 2.3.20

* Fri Sep 03 2021 Yang Shen <shenyang39@huawei.com> 2.3.11-4
- uadk-access-the-file-isolate-before-read-it.patch

* Fri Aug 06 2021 Pengju Jiang <jiangpengju2@huawei.com> 2.3.11-3
- bugfix-of-gcc-10.patch

* Wed Jul 21 2021 caodongxia <caodongxia@huawei.com> 2.3.11-2
- change uacce.h path.

* Tue Jul 06 2021 Hao Fang <fanghao11@huawei.com> 2.3.11-1
- update warpdrive to uadk, support kunpeng 920/930.

* Sun Mar 15 2020 zhangtao <zhangtao221@huawei.com> 1.2.10-3
- Specify compilation aarch64 as platform

* Tue Mar 03 2020 catastrowings <jianghuhao1994@163.com> 1.2.10-2
- openEuler init

* Tue Jan 07 2020 jinbinhua <jinbinhua@huawei.com> 1.2.7-1
- First Spec Version Include Warpdrive Code
